daqginterface - can it check, before start, for stale sharedmemory segments for the appropriate
partition?
Description

Wondering if daginterface can, before start when all processes are known to be down (i.e. valid shutdown), check for
stale shared memory segments?

History

#1 - 04/12/2019 06:55 PM - John Freeman

That would definitely be useful. The key there - no pun intended - is that DAQInterface would need to know what shared memory segments artdaq
was planning to create given the set of processes about to be launched and the partition in question and then checking to see if those segments
were already there. Not sure how straightforward that would be, but we can talk about it at the meeting on Monday.

#2 - 04/12/2019 07:02 PM - Eric Flumerfelt

| can certainly modify SharedMemoryEventManager so that the shared memory key at least reflects the partition number...probably 0OxBE##PPPP and
OxCE##PPPP where ## represents the partition number and PPPP is the PID.

#3 - 06/11/2019 08:16 AM - Eric Flumerfelt

I have implemented this change to SMEM on artdaq:feature/22372_SMEM_PartitionNumberinKey. The keys will be OXEE##PPPP for events and
0xBB##PPPP for broadcasts, where ## indicates the partition number and PPPP indicates the PID.

#4 - 09/01/2019 06:27 PM - John Freeman
- % Done changed from 0 to 80
- Assignee set to John Freeman

- Status changed from New to Assigned

I've created branch feature/issue22372_handle_orphaned_shmem, current head 85f214e137da06797dc23a0c5952a64b015¢73d2. Right now it
contains a script called "mopup_shmem.sh" which takes as an argument the partition number whose artdaqg processes' shared memory blocks you
want to clean up. It largely does what you'd expect it to (e.g., it refuses to run ipcrm if it sees that for the partition in question there's a live instance of
DAQInterface which hasn't been confirmed to be in the "stopped" state).

My next step's a simple one: I'll have DAQInterface call this script before launching artdaq processes on a given node.

#5 - 09/03/2019 02:02 PM - John Freeman
- % Done changed from 80 to 100

- Status changed from Assigned to Resolved

With commit e2bc8279da6025165cfd93c61680a20b19f277e5 at the head of DAQInterface's feature/issue22372_handle_orphaned_shmem:

e The DAQInterface side of this issue is now resolved

¢ As per an agreement via email with Eric, the process of resolving this issue has involved using artdaq's
feature/22372_SMEM_PartitionNumberIinKey branch, so that artdaq feature branch can be considered reviewed, with the caveat that the
partition number appears as one value higher in the keys of the shared memory blocks created by artdaq (e.g., partition 1 results in keys like
"0x02003005" and "0xbb02b1be")

Please note:
¢ On the boot transition DAQInterface will check for shared memory blocks associated with its partition and clean them up before launching the
processes by calling a new script called "mopup_shmem.sh" on every node on which artdaq processes will run

¢ To see the output of mopup_shmem.sh, set the "debug level" in the boot file to 4. You can also run "ipcs" before and after the boot transition.
¢ When reviewing this, a good technique to create orphaned shared memory blocks is to kill -9 DAQInterface after it's in the ready state. Then you
can proceed to see if this feature does what it's supposed to by relaunching DAQInterface and putting it through the boot transition.

#6 - 10/22/2019 11:31 AM - Eric Flumerfelt

In my testing, | found that this change does not deal with art processes left over; this causes subsequent launches to fail:

Will try to kill the following process since it owns at least one shared memory block:
/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/bin/mopup_shmem.sh: line 123: kill: (30215)
No such process

Will try to kill the following process since it owns at least one shared memory block:
/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/bin/mopup_shmem.sh: line 123: kill: (30216)
No such process

Will try to kill the following process since it owns at least one shared memory block:
/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/bin/mopup_shmem.sh: line 123: kill: (30217)
No such process

Will try to kill the following process since it owns at least one shared memory block:
/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/bin/mopup_shmem.sh: line 123: kill: (30218)
No such process

Tue Oct 22 10:38:08 CDT 2019: BOOT transition complete
QStandardPaths: XDG_RUNTIME_DIR not set, defaulting to '/tmp/runtime-eflumerf'
Tue Oct 22 10:38:09 CDT 2019: Appear to have lost process with label EventBuilderl on host localhost

Warning: unable to normally kill process(es) associated with now-deceased
artdaqg process EventBuilderl; on localhost the following pid(s) remain:
13984. Will now resort to kill -9 on these processes.

At least some of the processes on localhost related to deceased artdag

process EventBuilderl at localhost:5235 (e.g. art processes) had to be

forcibly killed; there *may* be issues with the next run using that host

and port as a result

Tue Oct 22 10:38:09 CDT 2019: Appear to have lost process with label EventBuilder2 on host localhost

Warning: unable to normally kill process(es) associated with now-deceased
artdaq process EventBuilder2; on localhost the following pid(s) remain:
13983. Will now resort to kill -9 on these processes.

At least some of the processes on localhost related to deceased artdag

process EventBuilder2 at localhost:5236 (e.g. art processes) had to be

forcibly killed; there *may* be issues with the next run using that host

and port as a result

Tue Oct 22 10:38:09 CDT 2019: Appear to have lost process with label Dataloggerl on host localhost

Warning: unable to normally kill process(es) associated with now-deceased
artdag process Dataloggerl; on localhost the following pid(s) remain:
13479. Will now resort to kill -9 on these processes.

At least some of the processes on localhost related to deceased artdag
process Dataloggerl at localhost:5265 (e.g. art processes) had to be
forcibly killed; there *may* be issues with the next run using that host
and port as a result

Tue Oct 22 10:38:10 CDT 2019: RECOVER transition underway

I've made a commit to the feature/issue22372_handle_orphaned_shmem branch which adds a function that checks for and kills any art processes
associated with the partition.

Otherwise, this issue has been tested and reviewed.

#7 - 11/11/2019 08:27 AM - Eric Flumerfelt

- Status changed from Resolved to Reviewed

#8 - 11/22/2019 01:56 PM - Eric Flumerfelt
- Target version set to artdaq_daginterface v3_07_00

- Status changed from Reviewed to Closed

04/06/2021 22


http://www.tcpdf.org

